#include <iostream>
#include <fstream>
#include "picture.h"

Picture::Picture(int x, int y): res_x(x), res_y(y)
{
    pixels.resize(x*y);
}


char to_char(Pixel p) {
    // TODO: usare caratteri diversi per pixel di valore diverso (ASCII art)
    return '#';
}
void Picture::fill_with_checkerboard() {
    Pixel colA(0,0,0);
    Pixel colB(0, 1, 0);
    for (int y = 0; y < res_y; y++)
    for (int x = 0; x < res_x; x++) {
        pixel(x, y) = ((x/10 + y/10) % 2 == 0) ? colB : colA; //costrutto ternario o condizionale: guardia tra parentesi->punto interrogativo->due punti
        
    }
}

void Picture::print_to_screen()const {
    for (int y = 0; y < res_y; y++) {
        for (int x = 0; x < res_x; x++) {
            std::cout << to_char(pixel(x, y)) << ' ';
        }
        std::cout << std::endl;
    }
}

// see: https://en.wikipedia.org/wiki/Netpbm#PPM_example
void Picture::save_as_pnm(const std::string &filename)const {
    std::ofstream file(filename);
    // header:
    file << "P3" << std::endl
         << res_x << ' ' << res_y << std::endl
         << 255 << std::endl;  // 255 = maximal value

    for (int y = 0; y < res_y; y++) {
        for (int x = 0; x < res_x; x++) {
            Pixel p = pixel(x, y);
            file << int(p.x*255) << ' ';
            file << int(p.y*255) << ' ';
            file << int(p.z*255) << ' ';
        }
        file << std::endl;
    }
    file.close();
}
