#include "ray.h"
#include "sphere.h"
#include "picture.h"

Picture render(){
    const Sphere s(
        Vec3(0.0f, 0.0f, 4.0f),
        0.5
    );
    const Scalar focal_length = 1; 
    Picture image(100, 100);
    const Vec3 POV(0, 0, 0);
    const Vec3 background(1, 1, 1);
    const Vec3 colorSphere(1, 0, 0);
    for (int y = 0; y < image.res_y; y++) 
        for (int x = 0; x < image.res_x; x++){
            //q è il punto sul piano immagine che corrisponde al punto x,y
            Vec3 q(
                (x - image.res_x/2)/(image.res_x/2.0),
                (y - image.res_y/2)/(image.res_y/2.0),
                focal_length
            );
            Ray r;
            r.origin = POV;
            r.direction = q.normalized() - POV;
            Scalar k = r.intersect(s);
            image.pixel(x, y) = (k==MISS) ? background : colorSphere;
        }

    return image;
}